
Const Lf_blink = 0                                '      .

Dim Adc_sensor_val As Long
Dim Adc_sensor_count As Byte
Dim Logic_flags As Byte                           ' . .  Lf_xxxx.


'Sub Get_press()                                   '    .
'  Local W As Word

'  W = Getadc(1)
'  Adc_sensor_val = Adc_sensor_val + W
'  Incr Adc_sensor_count

'End Sub


'Function Calc_press() As Integer                  '      0.1 mm.Hg.
'  Local Stmp As Single
'  Local Res As Integer

'  Stmp = Adc_sensor_val / Adc_sensor_count
'  Adc_sensor_val = 0
'  Adc_sensor_count = 0

'  Stmp = Stmp - Sensor_calibration                '  .
'  Stmp = Stmp * 5                                 '   5 .
'  Stmp = Stmp / 1024
'  Stmp = Stmp * 1000                              '   .

'  Stmp = Stmp / 5.99949                           '    0.1 mm.Hg.
'  Res = Stmp

'  Calc_press = Res
'End Function

Function Calc_press() As Integer                  '      0.1 mm.Hg.
  Local Stmp As Single
  Local Res As Integer
  Res = Getadc(1)
  Stmp = Res
  Stmp = Stmp - Sensor_calibration                '  .
  Stmp = Stmp * 5                                 '   5 .
  Stmp = Stmp / 1024
  Stmp = Stmp * 1000                              '   .
  Stmp = Stmp / 5.99949                           '    0.1 mm.Hg.
  Res = Stmp
  Calc_press = Res
End Function


'        .
Function Calc_power(byval Current_press As Integer , Byval Need_press As Integer) As Byte
   Local Res As Integer

   Need_press = Need_press And 255
   Need_press = Need_press * 10

   Res = Pid_update(need_press , Current_press)

   If Res > Cp_max Then
     Res = Cp_max
   Elseif Res < 0 Then
     Res = 0
   End If

   Calc_power = Res
End Function


Sub Set_power(byval Pow As Byte)                  '
  Local Tmp As Byte

  If Pow < Cp_min Or Current_pressure < Press_min Or Current_pressure > Press_max Then

    Compare2b = 20
    Compare2a = 250

  Else

    Pow = Cp_max - Pow
    Pow = Pow + Cp_min

    If Pow < 30 Then
      Tmp = Pow + 50
    Elseif Pow < 50 Then
      Tmp = Pow + 30
    Else
      Tmp = Pow + 10
    End If

    Compare2b = Tmp
    Compare2a = Pow

  End If

End Sub


Sub Display_workinfo()                            '           .
  Local Stmp As Single
  Local Resw As Word
  Local Tmp As Byte

  If Current_pow > 0 Then
    Stmp = Cp_max / Current_pow
    Stmp = Maxpower_rh / Stmp
    Resw = Stmp
  Else
    Resw = 0
  End If

  Locate 1 , 1
  Stmp = Current_pressure / 10
  Lcd Fusing(stmp , "###.#") ; " > " ; Setpoint_pressure ; " mm.Hg" ; Spc(8)

  Locate 2 , 1

  If Current_pressure < Press_min Or Current_pressure > Press_max Then
    Toggle Logic_flags.lf_blink
    If Logic_flags.lf_blink = 1 Then
      Lcd "Pressure error!"
    Else
      Lcd Spc(16)
    End If
  Elseif Int_detect <> 1 Then
    Tmp = Cp_max - Current_pow
    Tmp = Tmp + Cp_min
    Lcd Resw ; " W" ; Spc(16)
  Else
    Lcd "Not power!" ; Spc(6)
  End If

  Int_detect = 1

End Sub