$nocompile

' .
Dim Pid_igain As Single
Dim Pid_pgain As Single
Dim Pid_dgain As Single
Const Pid_imax = 30
Const Pid_imin = -30

Dim Pid_dstate As Single
Dim Pid_istate As Single

Dim Pid_pterm As Single
Dim Pid_dterm As Single
Dim Pid_iterm As Single
Dim Pid_error As Single

' Setpoint -    .
' Position -  .

Function Pid_update(byval Setpoint As Integer , Byval Position As Integer) As Integer

  Pid_error = Setpoint - Position

  Pid_pterm = Pid_pgain * Pid_error
  Pid_istate = Pid_istate + Pid_error

  If Pid_istate > Pid_imax Then
    Pid_istate = Pid_imax
  Elseif Pid_istate < Pid_imin Then
    Pid_istate = Pid_imin
  End If

  Pid_iterm = Pid_igain * Pid_istate
  Pid_dterm = Position - Pid_dstate
  Pid_dterm = Pid_dterm * Pid_dgain
  Pid_dstate = Position

  Pid_pterm = Pid_pterm + Pid_iterm
  Pid_pterm = Pid_pterm - Pid_dterm

  If Pid_pterm > 30000 Then
    Pid_pterm = 30000
  Elseif Pid_pterm < -30000 Then
    Pid_pterm = -30000
  End If

  Pid_update = Pid_pterm
End Function